package com.steerinfo.dil.controller;


import com.steerinfo.dil.model.QmsQueueResult;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.dil.service.IQmsQueueResultService;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import java.util.*;

/**
 * QmsQueueResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-14 11:27
 * 类描述
 * 修订历史：
 * 日期：2021-09-14
 * 作者：generator
 * 参考：
 * 描述：QmsQueueResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/qmsqueueresults")
public class QmsQueueResultController extends BaseRESTfulController {

    @Autowired
    IQmsQueueResultService qmsQueueResultService;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value="触发电子围栏-->新增排队实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "", required = false, dataType = "Map"),
    })
    @PostMapping("/addQueueResult")
    public RESTfulResult addQueueResult(@RequestBody(required = false) Map<String, Object> map){
        int i = qmsQueueResultService.addQueueResult(map);
        return success(i);
    }

    @ApiOperation(value="查询排队申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(125)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueApply")
    public RESTfulResult getQueueApply(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allQueueApply = qmsQueueResultService.getQueueApply(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueApply = qmsQueueResultService.getQueueApply(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueApply,queueApply);
        return success(pageList);
    }

    @ApiOperation(value="查询执行中订单")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(156)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getAllExecutionOrder")
    public RESTfulResult getAllExecutionOrder(@RequestBody(required=false) Map<String,Object> mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize,
                                       Integer orderType,
                                       Integer status
    ){
        if(mapValue == null){
            mapValue = new HashMap<>();
        }
        mapValue.put("orderTypee", orderType);
        mapValue.put("orderStatus", status);

        //不分页筛选数据
        List<Map<String, Object>> AllExecutionOrder = qmsQueueResultService.getAllExecutionOrder(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> executionOrder = qmsQueueResultService.getAllExecutionOrder(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, AllExecutionOrder,executionOrder);
        return success(pageList);
    }


    @ApiOperation(value="指令接收")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(130、190)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/orderReceive")
    public RESTfulResult orderReceive(@RequestBody(required=false) Map<String,Object> mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize,
                                       Integer queueType
    ){
        mapValue.put("queueType", queueType);
        //不分页筛选数据
        List<Map<String, Object>> allOrderReceive = qmsQueueResultService.orderReceive(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> orderReceive = qmsQueueResultService.orderReceive(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allOrderReceive,orderReceive);
        return success(pageList);
    }

    @ApiOperation(value="查询排队开始 网格Id视情况而给 可不给")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(128)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "gridId", value = "仓储网格(筛选)", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "type", value = "类型3：采购、1|2：销售", required = false, dataType = "Integer"),

    })
    @PostMapping("/getQueueListByQueueUp")
    public RESTfulResult getQueueListByQueueUp(@RequestBody(required=false) Map<String,Object> mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize,
                                       Integer gridId
    ){
        if(gridId != null){
            mapValue.put("gridId", gridId);
        }
        //不分页筛选数据
        List<Map<String, Object>> allQueueApply = qmsQueueResultService.getQueueListByQueueUp(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueApply = qmsQueueResultService.getQueueListByQueueUp(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueApply,queueApply);
        return success(pageList);
    }

    @ApiOperation(value="查询进厂排队详情")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(184)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getAllQueueMes")
    public RESTfulResult getAllQueueMes(@RequestBody(required=false) Map<String,Object> mapValue,
                                                 Integer apiId,
                                                 Integer pageNum,
                                                 Integer pageSize,
                                                 Integer gatepostId
    ){
        if(gatepostId != null){
            mapValue.put("gatepostId", gatepostId);
        }
        //不分页筛选数据
        List<Map<String, Object>> allQueueApply = qmsQueueResultService.getQueueMes(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueApply = qmsQueueResultService.getQueueMes(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueApply,queueApply);
        return success(pageList);
    }

    @ApiOperation(value="通过运输订单号查询进厂排队详情")
    @PostMapping("/getQueueMes")
    public RESTfulResult getQueueMes(Map<String, Object> map){
        List<Map<String, Object>> warehouseQueueMes = qmsQueueResultService.getQueueMes(map);
        return success(warehouseQueueMes);
    }

    @ApiOperation(value="查询排队转移")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(124)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getChangeQueue")
    public RESTfulResult getChangeQueue(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allChangeQueueMes = qmsQueueResultService.getChangeQueueMes(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> changeQueueMes = qmsQueueResultService.getChangeQueueMes(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allChangeQueueMes,changeQueueMes);
        return success(pageList);
    }

    @ApiOperation(value="查询排队取消")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(131)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueCancel")
    public RESTfulResult getQueueCancel(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize,
                                               Integer gatepostId
    ){
        if(gatepostId != null){
            mapValue.put("gatepostId", gatepostId);
        }
        //不分页筛选数据
        List<Map<String, Object>> allQueueCancel = qmsQueueResultService.getQueueCancel(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueCancel = qmsQueueResultService.getQueueCancel(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueCancel,queueCancel);
        return success(pageList);
    }

    @ApiOperation(value="通过Id查询排队取消实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "排队取消实绩", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueCancelByResultId/{resultId}")
    public RESTfulResult getQueueCancelByResultId(@PathVariable("resultId") Integer resultId){
        List<Map<String, Object>> mes = qmsQueueResultService.getQueueCancelByResultId(resultId);
        return success(mes);
    }

    @ApiOperation(value="修改排队取消实绩：时间、原因")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "qmsQueueResult", value = "排队取消实体类", required = false, dataType = "QmsQueueResult"),
    })
    @PostMapping("/updateQueueCancel")
    public RESTfulResult updateQueueCancel(@RequestBody QmsQueueResult qmsQueueResult){
        int i = qmsQueueResultService.updateQueueCancel(qmsQueueResult);
        return success(i);
    }

    @ApiOperation(value="查询排队插队")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(132)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueInsert")
    public RESTfulResult getQueueInsert(@RequestBody(required=false) Map<String,Object> mapValue,
                                        Integer apiId,
                                        Integer pageNum,
                                        Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allInsetResult = qmsQueueResultService.getQueueInsert(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> insertResult = qmsQueueResultService.getQueueInsert(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allInsetResult,insertResult);
        return success(pageList);
    }

    @ApiOperation(value="查询排队结束")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(133)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueEndResult")
    public RESTfulResult getQueueEndResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                              Integer apiId,
                                              Integer pageNum,
                                              Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allQueueEndResult = qmsQueueResultService.getQueueEndResult(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueEndResult = qmsQueueResultService.getQueueEndResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueEndResult,queueEndResult);
        return success(pageList);
    }

    @ApiOperation(value="汽车监控(仓库)")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(135、)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/capacityMonitor")
    public RESTfulResult capacityMonitor(@RequestBody(required=false) Map<String,Object> mapValue,
                                           Integer apiId,
                                           Integer pageNum,
                                           Integer pageSize,
                                           Integer gridType
    ){
        mapValue.put("gridType", gridType);
        //不分页筛选数据
        List<Map<String, Object>> allCapacityMonitor = qmsQueueResultService.capacityMonitor(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> capacityMonitor = qmsQueueResultService.capacityMonitor(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allCapacityMonitor,capacityMonitor);
        return success(pageList);
    }


    @ApiOperation(value="查询各仓库，门岗的排队状态列表")
    @PostMapping("/getQueueStatusList")
    public RESTfulResult getQueueStatusList(){
        List<Map<String, Object>> queueStatusList = qmsQueueResultService.getQueueStatusList();
        return success(queueStatusList);
    }

    @ApiOperation(value="通过车牌号查询司机接收排队信息")
    @PostMapping("/getOrderReceive/{capacityNumber}")
    public RESTfulResult getOrderReceive(@PathVariable("capacityNumber") String capacityNumber){
        List<Map<String, Object>> orderReceiveMap = qmsQueueResultService.getOrderReceive2(capacityNumber);
        return success(orderReceiveMap);
    }

    @ApiOperation(value="通过车牌号取消排队")
    @PostMapping("/cancelQueue")
    public RESTfulResult cancelQueue(@RequestBody Map<String,Object> mapValue){
        int code = qmsQueueResultService.cancelQueue(mapValue);
        return success(code);
    }

    //========================================仓库=====================================================
    @ApiOperation(value="新增仓库排队")
    @PostMapping("/addQueueResultByCk")
    public RESTfulResult addQueueResultByCk(@RequestBody Map<String,Object> mapValue){
        int code = qmsQueueResultService.addQueueResultByCk(mapValue);
        return success(code);
    }

    @ApiOperation(value="查询仓库排队申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(187)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getWarehouseQueueApply")
    public RESTfulResult getWarehouseQueueApply(@RequestBody(required=false) Map<String,Object> mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allWarehouseQueueApply = qmsQueueResultService.getWarehouseQueueApply(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> warehouseQueueApply = qmsQueueResultService.getWarehouseQueueApply(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allWarehouseQueueApply,warehouseQueueApply);
        return success(pageList);
    }

    @ApiOperation(value="查询仓库排队开始")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(191)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getWarehouseQueueListByQueueUp")
    public RESTfulResult getWarehouseQueueListByQueueUp(@RequestBody(required=false) Map<String,Object> mapValue,
                                                Integer apiId,
                                                Integer pageNum,
                                                Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allWarehouseQueueApply = qmsQueueResultService.getWarehouseQueueListByQueueUp(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> warehouseQueueApply = qmsQueueResultService.getWarehouseQueueListByQueueUp(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allWarehouseQueueApply,warehouseQueueApply);
        return success(pageList);
    }

    @ApiOperation(value="查询仓库排队详情")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(192)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getAllWarehouseQueueMes")
    public RESTfulResult getAllWarehouseQueueMes(@RequestBody(required=false) Map<String,Object> mapValue,
                                                        Integer apiId,
                                                        Integer pageNum,
                                                        Integer pageSize,
                                                        Integer platformId
    ){
        if(platformId != null){
            mapValue.put("platformId", platformId);
        }
        //不分页筛选数据
        List<Map<String, Object>> allWarehouseQueueApply = qmsQueueResultService.getWarehouseQueueMes(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> warehouseQueueApply = qmsQueueResultService.getWarehouseQueueMes(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allWarehouseQueueApply,warehouseQueueApply);
        return success(pageList);
    }

    @ApiOperation(value="通过运输订单号查询仓库排队详情")
    @PostMapping("/getWarehouseQueueMes")
    public RESTfulResult getWarehouseQueueMes(Map<String, Object> map){
        List<Map<String, Object>> warehouseQueueMes = qmsQueueResultService.getWarehouseQueueMes(map);
        return success(warehouseQueueMes);
    }


    @ApiOperation(value="查询仓库排队转移")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(193)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getWarehouseQueueChange")
    public RESTfulResult getWarehouseQueueChange(@RequestBody(required=false) Map<String,Object> mapValue,
                                                 Integer apiId,
                                                 Integer pageNum,
                                                 Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allWarehouseQueueChange = qmsQueueResultService.getWarehouseQueueChange(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> warehouseQueueChange = qmsQueueResultService.getWarehouseQueueChange(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allWarehouseQueueChange,warehouseQueueChange);
        return success(pageList);
    }

    @ApiOperation(value="查询仓库排队结束")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(194)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
    })
    @PostMapping("/getWarehouseQueueEndMes")
    public RESTfulResult getWarehouseQueueEndMes(@RequestBody(required=false) Map<String,Object> mapValue,
                                                 Integer apiId,
                                                 Integer pageNum,
                                                 Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allWarehouseQueueEndMes = qmsQueueResultService.getWarehouseQueueEndMes(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> warehouseQueueEndMes = qmsQueueResultService.getWarehouseQueueEndMes(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, warehouseQueueEndMes,allWarehouseQueueEndMes);
        return success(pageList);
    }


}
