package com.steerinfo.dil.mapper;

import org.mapstruct.Mapper;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/16 10:01
 */
@Mapper
public interface QueuingRulesMapper {
    //查询订单跟订单物资中间表 查询是否有多个物资Id
    List<Integer> getAllMaterialId(Map<String, Object> map);

    //通过物资Id查询仓库是否有货 或者 是否有多个仓库有货
    List<Integer> getWarehouseIdByMaterialId(Integer materialId);

    //通过仓库Id 和 物资Id 查询垛位 层次 月台 仓库
    List<Map<String, Object>> getStackGradation(Map<String, Object> map);

    //通过月台Id 查询月台当前排队车辆数
    BigDecimal queueCountByPlatformId(BigDecimal platformId);

    //如果当前状态满足之前所有条件 则根据仓库优先级进行选择仓库

}
